image: docker:19.03

variables:
  REPOSITORY_URL: 975050281995.dkr.ecr.us-east-1.amazonaws.com/appwindows
  
services:
- docker:dind
stages:
  - test
  - package
  - build
  - deploy

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    - merge_requests
    - master
    - develop


package site:
  stage: package
  cache:
    key: site-package
    policy: push
    paths:
      - ./builds/clayton.souza/appwindows
  artifacts:
    name: "$CI_JOB_NAME-$CI_COMMIT_REF_NAME"
    when: always
    expire_in: 2h20min
    paths:
      - views
  script:
    - apk add --no-cache curl jq python3 py-pip 
    - apk update awscli bash
    - pip install awscli
    - aws s3 ls
    - IMAGE_TAG="$(echo $CI_COMMIT_SHA | head -c 8)"
    - pwd

build:
  image: docker:19.03
  stage: build
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  services:
    - docker:dind
  script:
    - apk add --no-cache curl jq python3 py-pip 
    - apk update awscli bash
    - pip install awscli
    - aws s3 ls
    - IMAGE_TAG="$(echo $CI_COMMIT_SHA | head -c 8)"
    - pwd
    - echo $AWS_PROFILE
    - CREDENTIALS=$(aws ecr get-login --no-include-email --region us-east-1 | sed 's|https://||')
    - USER=$(echo $CREDENTIALS | cut -d ' ' -f 4)
    - PASSWORD=$(echo $CREDENTIALS | cut -d ' ' -f 6)
    - docker login -u $USER -p $PASSWORD https://975050281995.dkr.ecr.us-east-1.amazonaws.com/appwindows
    - docker build -t $REPOSITORY_URL:$IMAGE_TAG .
    - echo "Tagging image..."
    - docker tag $REPOSITORY_URL:$IMAGE_TAG $REPOSITORY_URL:$IMAGE_TAG
    - echo "Pushing image..."
    - docker push $REPOSITORY_URL:$IMAGE_TAG
    - docker push $REPOSITORY_URL
  only:
    - master
     
deploy:
  image: docker:19.03
  stage: deploy
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  services:
    - docker:dind
  script:
    - apk add --no-cache curl jq python3 py-pip 
    - apk update awscli bash
    - pip install awscli
    - aws s3 ls
    - IMAGE_TAG="$(echo $CI_COMMIT_SHA | head -c 8)"
    - pwd
    - echo $AWS_PROFILE
    - CREDENTIALS=$(aws ecr get-login --no-include-email --region us-east-1 | sed 's|https://||')
    - USER=$(echo $CREDENTIALS | cut -d ' ' -f 4)
    - PASSWORD=$(echo $CREDENTIALS | cut -d ' ' -f 6)
    - echo $REPOSITORY_URL:$IMAGE_TAG
    - TASK_DEFINITION=$(aws ecs describe-task-definition --task-definition "$TASK_DEFINTION_NAME" --region "${REGION}")
    - NEW_CONTAINER_DEFINTIION=$(echo $TASK_DEFINITION | jq --arg IMAGE "$REPOSITORY_URL:$IMAGE_TAG" '.taskDefinition.containerDefinitions[0].image = $IMAGE | .taskDefinition.containerDefinitions[0]')
    - echo "Registering new container definition..."
    - aws ecs register-task-definition --region "${REGION}" --family "${TASK_DEFINTION_NAME}" --container-definitions "${NEW_CONTAINER_DEFINTIION}"
    - echo "Updating the service..."
    - aws ecs update-service --region "${REGION}" --cluster "${CLUSTER_NAME}" --service "${SERVICE_NAME}"  --task-definition "${TASK_DEFINTION_NAME}"
  only:
    - master

